commit d021d9bddfbe66cfec7027999aa3ee501198e20a
Author: Jeremy Harris <jgh146exb@wizmail.org>
Date:   Sun Nov 2 10:12:55 2025 +0000

    tidying

diff --git a/src/src/tls-gnu.c b/src/src/tls-gnu.c
index 80fb419d0..154d3be38 100644
--- a/src/src/tls-gnu.c
+++ b/src/src/tls-gnu.c
@@ -2163,10 +2163,7 @@ if (host)
   /* For client-side sessions we allocate a context. This lets us run
   several in parallel. */
 
-  int old_pool = store_pool;
-  store_pool = POOL_PERM;
-  state = store_get(sizeof(exim_gnutls_state_st), GET_UNTAINTED);
-  store_pool = old_pool;
+  state = store_get_perm(sizeof(exim_gnutls_state_st), GET_UNTAINTED);
 
   memcpy(state, &exim_gnutls_state_init, sizeof(exim_gnutls_state_init));
   state->lib_state = ob->tls_preload;
@@ -2806,7 +2803,7 @@ char sni_name[MAX_HOST_LEN];
 size_t data_len = MAX_HOST_LEN;
 exim_gnutls_state_st *state = &state_server;
 unsigned int sni_type;
-int rc, old_pool;
+int rc;
 uschar * dummy_errstr;
 
 rc = gnutls_server_name_get(session, sni_name, &data_len, &sni_type, 0);
@@ -2828,10 +2825,7 @@ if (sni_type != GNUTLS_NAME_DNS)
   }
 
 /* We now have a UTF-8 string in sni_name */
-old_pool = store_pool;
-store_pool = POOL_PERM;
-state->received_sni = string_copy_taint(US sni_name, GET_TAINTED);
-store_pool = old_pool;
+state->received_sni = string_copy_perm(US sni_name, TRUE);
 
 /* We set this one now so that variable expansions below will work */
 state->tlsp->sni = state->received_sni;
@@ -4386,8 +4380,9 @@ host_item * h;
 int old_pool = store_pool;
 
 store_pool = POOL_PERM;
-state = store_get(sizeof(exim_gnutls_state_st), GET_UNTAINTED);
-h = store_get(sizeof(host_item), GET_UNTAINTED);
+state = store_get(sizeof(exim_gnutls_state_st) + sizeof(host_item),
+		  GET_UNTAINTED);
+h = ((host_item *)state) + 1;
 
 memset(h, 0, sizeof(host_item));
 h->name = h->address = string_copy(ipaddr);
@@ -4419,12 +4414,8 @@ store_pool = old_pool;
 void
 tls_state_out_to_in(int newfd, const uschar * ipaddr, int port)
 {
-host_item * h;
-int old_pool = store_pool;
+host_item * h = store_get_perm(sizeof(host_item), GET_UNTAINTED);
 
-store_pool = POOL_PERM;
-h = store_get(sizeof(host_item), GET_UNTAINTED);
-store_pool = old_pool;
 memset(h, 0, sizeof(host_item));
 h->name = h->address = string_copy(ipaddr);
 h->port = port;
diff --git a/src/src/tls-openssl.c b/src/src/tls-openssl.c
index d5a6d368d..ddc72bfa2 100644
--- a/src/src/tls-openssl.c
+++ b/src/src/tls-openssl.c
@@ -2231,7 +2231,6 @@ tls_servername_cb(SSL * s, int * ad ARG_UNUSED, void * arg)
 const char * servername = SSL_get_servername(s, TLSEXT_NAMETYPE_host_name);
 exim_openssl_state_st * state = (exim_openssl_state_st *) arg;
 int rc;
-int old_pool = store_pool;
 uschar * errstr;
 
 if (!servername)
@@ -2241,9 +2240,7 @@ DEBUG(D_tls) debug_printf("Received TLS SNI %q%s\n", servername,
     reexpand_tls_files_for_sni ? "" : " (unused for certificate selection)");
 
 /* Make the extension value available for expansion */
-store_pool = POOL_PERM;
-tls_in.sni = string_copy_taint(US servername, GET_TAINTED);
-store_pool = old_pool;
+tls_in.sni = string_copy_perm(US servername, TRUE);
 
 if (!reexpand_tls_files_for_sni)
   return SSL_TLSEXT_ERR_OK;
@@ -3119,13 +3116,8 @@ return cipher_stdname(id >> 8, id & 0xff);
 static const uschar *
 tlsver_name(const SSL * ssl)
 {
-const uschar * s;
-uschar * p;
-int pool = store_pool;
+uschar * s = string_copy_perm(US SSL_get_version(ssl), FALSE), * p;
 
-store_pool = POOL_PERM;
-s = string_copy(US SSL_get_version(ssl));
-store_pool = pool;
 if ((p = Ustrchr(s, 'v')))	/* TLSv1.2 -> TLS1.2 */
   for (;; p++) if (!(*p = p[1])) break;
 return CUS s;
@@ -3151,12 +3143,8 @@ if (tlsp->peercert)
     { DEBUG(D_tls) debug_printf("X509_NAME_oneline() error\n"); }
   else
     {
-    int oldpool = store_pool;
-
     peerdn[siz-1] = '\0';		/* paranoia */
-    store_pool = POOL_PERM;
-    tlsp->peerdn = string_copy(peerdn);
-    store_pool = oldpool;
+    tlsp->peerdn = string_copy_perm(peerdn, TRUE);
 
     /* We used to set CV in the cert-verify callbacks (either plain or dane)
     but they don't get called on session-resumption.  So use the official
@@ -4237,11 +4225,9 @@ BOOL request_ocsp = FALSE;
 BOOL require_ocsp = FALSE;
 #endif
 
-rc = store_pool;
-store_pool = POOL_PERM;
-exim_client_ctx = store_get(sizeof(exim_openssl_client_tls_ctx), GET_UNTAINTED);
+exim_client_ctx = store_get_perm(sizeof(exim_openssl_client_tls_ctx),
+				GET_UNTAINTED);
 exim_client_ctx->corked = NULL;
-store_pool = rc;
 
 #ifdef SUPPORT_DANE
 tlsp->tlsa_usage = 0;
@@ -5268,18 +5254,16 @@ void
 tls_state_in_to_out(int newfd, const uschar * ipaddr, int port)
 {
 exim_openssl_client_tls_ctx * exim_client_ctx;
-int old_pool = store_pool;
 
 state_server.is_server = FALSE;
 state_server.tlsp = &tls_out;
 client_static_state = &state_server;
 
-store_pool = POOL_PERM;
-exim_client_ctx = store_get(sizeof(exim_openssl_client_tls_ctx), GET_UNTAINTED);
+exim_client_ctx = store_get_perm(sizeof(exim_openssl_client_tls_ctx),
+				GET_UNTAINTED);
 exim_client_ctx->ctx = client_static_state->lib_state.lib_ctx;
 exim_client_ctx->ssl = client_static_state->lib_state.lib_ssl;
 exim_client_ctx->corked = NULL;
-store_pool = old_pool;
 
 SSL_set_fd(exim_client_ctx->ssl, newfd);
 

